#pragma once

//std lib
// #include <sstream>
// #include <vector>
//opencv
// #include "opencv2/opencv.hpp"
// #include "opencv2/imgproc/imgproc.hpp"
//bgslib
#include "IBGS.h"

#include "opencv2/core/version.hpp"
#if CV_MAJOR_VERSION >= 2 && CV_MAJOR_VERSION <= 3

#include "ttoolbox.h"
#include "lb/BGModel.h"
// #include "lb/BGModel.h"


namespace bgslibrary
{
  namespace algorithms
  {
    class Tapter : public IBGS
    {
    private:
      lb::BGModel* m_pBGModel; //TODO put in some kind of smartpointer.
      int sensitivity;
      int trainingSensitivity;
      int learningRate;
      int trainingLearningRate;
      int trainingSteps;

    public:
      Tapter();
      ~Tapter();

      void process(const cv::Mat &img_input, cv::Mat &img_output, cv::Mat &img_bgmodel);

    private:
      void save_config(cv::FileStorage &fs);
      void load_config(cv::FileStorage &fs);
    };

    bgs_register(Tapter);
  }
}

#endif
